VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ParseBrackets"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'******* 1.30k Start *******
'Code supplied by VB Forums member dilettante
Public Enum ParseResults
    prOk = 0
    prUnbalanced = 1
End Enum

Public Enum SortOrders
    soNone = 0
    soAscending = 1
    soDescending = 2
End Enum

Public BeginBracket As String
Public EndBracket As String
Public Sorting As SortOrders
Public Nodes As Collection
'******* 1.30k End *********
Public Function Parse(ByRef Text As String) As ParseResults
    Dim Pos As Long
    Dim Length As Long
    Dim Number As Long
    Dim BeginPos As Long
    Dim EndPos As Long
    Dim Level As Long
    Dim NodeStack As Collection
    Dim Node As ParsedNode
    
    Set Nodes = New Collection
    Set NodeStack = New Collection
    Pos = 1
    Length = Len(Text)
    Do
        BeginPos = InStr(Pos, Text, BeginBracket, vbTextCompare)
        If BeginPos = 0 Then BeginPos = Length + 1
        EndPos = InStr(Pos, Text, EndBracket, vbTextCompare)
        If EndPos = 0 Then EndPos = Length + 1
        
        If BeginPos > EndPos Then
            'End first?
            If Length > EndPos Then
                'Found End.
                If NodeStack.Count > 0 Then
                    Set Node = NodeStack.Item(NodeStack.Count)
                    NodeStack.Remove NodeStack.Count
                    Node.EndPos = EndPos
                    If Sorting = soNone Then
                        Nodes.Add Node
                    Else
                        'Insert into result Nodes collection in requested order by Node.Number.
                        On Error Resume Next
                        If Sorting = soAscending Then
                            Nodes.Add Node, "K" & CStr(Node.Number), "K" & CStr(Node.Number + 1)
                            If Err Then
                                Nodes.Add Node, "K" & CStr(Node.Number)
                            End If
                        Else
                            Nodes.Add Node, "K" & CStr(Node.Number), , "K" & CStr(Node.Number + 1)
                            If Err Then
                                Err.Clear
                                Nodes.Add Node, "K" & CStr(Node.Number), 1
                                If Err Then
                                    Nodes.Add Node, "K" & CStr(Node.Number)
                                End If
                            End If
                        End If
                        On Error GoTo 0
                    End If
                    Level = Level - 1
                    Pos = EndPos + 1
                Else
                    'End with no corresponding Begin.
                    Parse = prUnbalanced
                    Exit Do
                End If
            Else
                'Missing End.
                Parse = prUnbalanced
                Exit Do
            End If
        ElseIf BeginPos > Length And EndPos > Length Then
            'Done.
            Exit Do
        Else
            'Begin first?
            If Length > BeginPos Then
                'Found Begin.
                Set Node = New ParsedNode
                NodeStack.Add Node
                With Node
                    Number = Number + 1
                    .Number = Number
                    .BeginPos = BeginPos
                    Level = Level + 1
                    ' My change
'                    .Level = Level
                    .Level = Level - 1
                    
                End With
                Pos = BeginPos + 1
            ElseIf BeginPos = EndPos Then
                'Missing End.
                Parse = prUnbalanced
                Exit Do
            Else
                'Done.
                Exit Do
            End If
        End If
    Loop Until Pos >= Length
    If Node.EndPos = 0 Then
        'Missing end.
        Parse = prUnbalanced
    End If
    Set NodeStack = Nothing
End Function

