VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMarkup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mRTB As RichTextBox
Private mKeyWords() As String
'******* 1.10 Start *******
Private mNewKeyWords() As String
'******* 1.10 End *********
Private mkeyMax As Integer
Private Const QUOTE_CAPTION = " Quote "
Private Const QUOTE_POSTED_BY = "Originally Posted By "


Public Sub SetRTB(RTB As RichTextBox)
    Set mRTB = RTB
End Sub
Public Sub MarkQuote(Optional strName As String = "")

Dim curFont As String
Dim lStart As Long
Dim lLen As Long
Dim strCode As String
'******* 1.10 Start *******
'Dim lcolor1 As Long
'******* 1.10 End *********

Dim lngQuoteColor As Long
'******* 1.30k Start *******
'Dim halfWidth As Integer
Const halfWidth = 20
'******* 1.30k End *********

Dim curColor As Long
 
'******* 1.30k Start *******
'halfWidth = 20
'******* 1.30k End *********

 '******* 1.10 Start *******
' lcolor1 = vbRed
' lngQuoteColor = vbBlue
 lngQuoteColor = 9109643 'Dark Magenta
 '******* 1.10 End *********
 
 lStart = mRTB.SelStart
 lLen = mRTB.SelLength
 
 With mRTB
    lStart = .SelStart
    lLen = .SelLength
'
    If strName > "" Then
        CaptionBar QUOTE_CAPTION, halfWidth, lngQuoteColor, vbBlack, strName
    Else
        CaptionBar QUOTE_CAPTION, halfWidth, lngQuoteColor, vbBlack
    End If
    '******* 1.30k Start *******
'    .SelStart = InStr(1, .Text, TAG_QUOTE_END) + Len(TAG_QUOTE_END) - 1
    frmViewer.FindQuotePairs
    .SelStart = QuotePairsText(1).EndLocation + Len(TAG_QUOTE_END)
    '******* 1.30k End *********
    CaptionBar "", halfWidth + Int(Len(QUOTE_CAPTION) \ 2), lngQuoteColor, vbBlack
  
    '******* 1.30k Start *******
    'move cursor past new insert
'    .SelStart = lStart + lLen + 2 * halfWidth + Len(QUOTE_CAPTION) + 3
'    .SelLength = 0
    '******* 1.30k End *********
    
End With

End Sub

Public Sub MarkupAsCpp()
Dim curFont As String
Dim lStart As Long
Dim lLen As Long
Dim strCode As String
Dim curColor As Long
  
  With mRTB
    'save current font
    curFont = .SelFontName
    curColor = .SelColor
    
    'save length of selection
    lLen = .SelLength


    '1st separator
    CaptionBar CppCaption, 20, vbRed, vbBlack
    
    lStart = .SelStart
    .SelLength = lLen
    strCode = .SelText
    .SelFontName = "Courier New"
'    doKeyWords strCode, lStart
    doComments strCode, lStart, "//"
    doCommentBlocks strCode, lStart, "/*", "*/"
    doQuotes strCode, lStart
    
    'move to end of selection
    mRTB.SelStart = lStart + lLen
    
    '2nd separator
    CaptionBar "", 20 + Int(Len(CppCaption) \ 2), vbRed, vbBlack
    
    'move cursor past new insert
    .SelStart = lStart + lLen + 2 * 20 + Len(CppCaption) + 3
    .SelLength = 0
    .SelFontName = curFont
    .SelColor = curColor
  End With
  
End Sub

Private Sub doComments(strCode As String, lStart As Long, Optional char As String = "'")
'Used for Markups
'make all comments green
    Dim i As Long
    Dim j As Long

    On Error GoTo ErrorRoutine

    With mRTB
        i = InStr(1, strCode, char)
        While i > 0
            .SelStart = i - 1 + lStart
        
            j = InStr(i, strCode, vbCrLf)
            .SelLength = j - i
            .SelColor = RGB(0, &H7A, 0)
        'Here is an example of a comment
            i = InStr(j + 1, strCode, char)
        Wend
        
    End With

    Exit Sub

ErrorRoutine:
    '******* 1.30n Start *******
    ' Sometimes a ' in the interior of a line can cause problems but for now at least who cares.
    If Err.Number = 380 Then
        Exit Sub
    Else
        DisplayError "doComments"
    End If
    '******* 1.30n End *********
End Sub
Private Sub doParens(strCode As String, lStart As Long, Optional char As String = "'")
'Used for Markups
'make open and close parens lime
'******* 1.10 Start *******
    Dim lngIndex As Long

    With mRTB
        Do
            lngIndex = InStr(lngIndex + 1, strCode, "(")
            If lngIndex = 0 Then Exit Do
            .SelStart = lngIndex + lStart - 1
            .SelLength = 1
            .SelColor = RGB(0, &HFF, 0)
        Loop While lngIndex > 0
        
        lngIndex = 0
        Do
            lngIndex = InStr(lngIndex + 1, strCode, ")")
            If lngIndex = 0 Then Exit Do
            .SelStart = lngIndex + lStart - 1
            .SelLength = 1
            .SelColor = RGB(0, &HFF, 0)
        Loop While lngIndex > 0
    End With
'******* 1.10 End *********
End Sub

Private Sub doNumbers(strCode As String, lStart As Long, Optional char As String = "'")
'Used for Markups
'make standalone numbers magenta
    '******* 1.10 Start *******
    Dim lngIndex As Long

    With mRTB
        For lngIndex = 1 To Len(strCode)
            If IsNumeric(Mid$(.Text, lStart + lngIndex, 1)) Then
                If Mid$(.Text, lStart + lngIndex - 1, 1) = " " Or _
                   Mid$(.Text, lStart + lngIndex - 1, 1) = "(" Or _
                   IsNumeric(Mid$(.Text, lStart + lngIndex - 1, 1)) Then
                    .SelStart = lngIndex + lStart - 1
                    .SelLength = 1
                    .SelColor = RGB(&HFF, 0, &HFF)
                End If
            End If
        Next
    End With
    '******* 1.10 End *********
End Sub

'Public Sub MarkupAsVB()
Public Sub MarkupAsVB(strType As String)

Dim curFont As String
Dim curColor As Long
Dim lLen As Long
Dim lStart As Long
Dim strCode As String
'******* 1.10 Start *******
Dim bFooter As Boolean
'******* 1.10 End *********
'******* 1.30n Start *******
Dim strStartTag As String
Dim strEndTag As String
Dim strCaption As String

    Select Case strType
        Case TAG_VBCODE_START
            strStartTag = strType
            strEndTag = TAG_VBCODE_END
            strCaption = VBCaption
        Case TAG_CODE_START
            strStartTag = strType
            strEndTag = TAG_CODE_END
            strCaption = CodeCaption
    End Select
'******* 1.30n End *********
    
  With mRTB
    'save current font
    curFont = .SelFontName
    'and current color
    '******* 1.10 Start *******
'    curColor = .SelColor
    '******* 1.10 End *********
    If IsNull(.SelColor) Then
        curColor = vbBlack
    Else
        curColor = .SelColor
    End If

    'save length of selection
    lLen = .SelLength

    '1st separator
    '******* 1.30n Start *******
'    VBCaptionBar True
    VBCaptionBar True, strType
    '******* 1.30n End *********
    
    '******* 1.10 Start *******
'    .SelStart = InStr(.Text, TAG_VBCODE_START)
    bFooter = True
    If bFooter Then
        '******* 1.30n Start *******
'        .SelStart = InStr(1, .Text, TAG_VBCODE_START) + Len(TAG_VBCODE_START)
        .SelStart = InStr(1, .Text, strStartTag) + Len(strStartTag)
        '******* 1.30n End *********
    End If
    '******* 1.10 End *********
    
    lStart = .SelStart
    '******* 1.10 Start *******
'    .SelLength = lLen
    '******* 1.30n Start *******
'    .SelLength = InStr(.SelStart, .Text, TAG_VBCODE_END) - (.SelStart + 1)
    '******* 1.30n End *********
    .SelLength = InStr(.SelStart, .Text, strEndTag) - (.SelStart + 1)
    '******* 1.10 End *********
    
    strCode = .SelText
    .SelFontName = "Courier New"
    .SelColor = 0
    
    ' Replace the brackets in the temporary string with a space so that for
    ' example the "With" in "End With[/VBCODE]" will be recognized as a separate word.
'    strCode = Replace(strCode, "[", " ", 1)
'    strCode = Replace(strCode, "]", " ", 1)

    doKeyWords strCode, lStart
    doComments strCode, lStart
    
    'move to end of selection
    mRTB.SelStart = lStart + lLen
    
    '2nd separator
    'CaptionBar "", halfWidth + Int(Len(VBCaption) \ 2), vbRed, vbBlack
    '******* 1.30n Start *******
'    VBCaptionBar False
    VBCaptionBar False, strType
    '******* 1.30n End *********
    
    'move cursor past new insert
    '******* 1.30n Start *******
'    .SelStart = lStart + lLen + 2 * VBBARLEN + Len(VBCaption) + 1
    .SelStart = lStart + lLen + 2 * VBBARLEN + Len(strCaption) + 1
    '******* 1.30n End *********

    .SelLength = 0
    .SelFontName = curFont
    .SelColor = curColor
    
  End With
End Sub


Public Sub MarkupAsCode(strStartTag As String, strEndTag As String)

    '******* 1.10 Start *******
    Dim curFont As String
    Dim curColor As Long
    Dim lLen As Long
    Dim lStart As Long
    Dim strCode As String
    Dim bFooter As Boolean

    With mRTB
        'save current font
        curFont = .SelFontName
        'and current color
        curColor = .SelColor
    
        'save length of selection
        lLen = .SelLength
    
        '1st separator
        HighlightCaptionBar True, strStartTag, strEndTag
        
        .SelStart = InStr(1, .Text, strStartTag) + (Len(strStartTag) - 1)
        
        lStart = .SelStart
        .SelLength = InStr(.SelStart, .Text, strEndTag) - (.SelStart + 1)
        
        strCode = .SelText
        
        .SelFontName = "Courier New"
        .SelColor = 0
        
        ' TODO - check keyword in an example where End With is the last line of code
        ' TODO - maybe I need to do this and then put the tags back (how?) after dokeywords
        ' Replace the brackets in the temporary string with a space so that for
        ' example the "With" in "End With[/VBCODE]" will be recognized as a separate word.
    '    strCode = Replace(strCode, "[", " ", 1)
    '    strCode = Replace(strCode, "]", " ", 1)
    
        doNewKeyWords strCode, lStart
        doComments strCode, lStart
        doQuotes strCode, lStart
        doParens strCode, lStart
        doNumbers strCode, lStart
        doLineNumbers strStartTag, strEndTag
        
        'move to end of selection
        mRTB.SelStart = lStart + lLen
        
        '2nd separator
        HighlightCaptionBar False, strStartTag, strEndTag
        
        'move cursor past new insert
        '******* 1.30n Start *******
'        .SelStart = lStart + lLen + 2 * VBBARLEN + Len(VBCaption) + 1
        If InStr(.Text, TAG_VBCODE_END) Then
            .SelStart = lStart + lLen + 2 * VBBARLEN + Len(VBCaption) + 1
        Else
            .SelStart = lStart + lLen + 2 * VBBARLEN + Len(CodeCaption) + 1
        End If
        '******* 1.30n End *********
        
        .SelLength = 0
        .SelFontName = curFont
        .SelColor = curColor
        
    End With
    '******* 1.10 End *********
End Sub

Private Sub doQuotes(strCode As String, lStart As Long)
'Used for VB Markup
'Make all quoted text red
    Dim i As Long
    Dim j As Long

    With mRTB
        'look for 1st quote
        i = InStr(1, strCode, Chr(34))
        While i > 0
            'closing quote
            j = InStr(i + 1, strCode, Chr(34))
            'if opening quote is green, then skip this one
            .SelStart = i - 1 + lStart
            .SelLength = 1
            If .SelColor <> RGB(0, &H7A, 0) Then
                .SelStart = i + lStart
                .SelLength = j - i - 1
                .SelColor = RGB(&H7A, 0, 0)
                'if closing quote is green, then change back to default
                .SelStart = j - 1 + lStart
                .SelLength = 1
                If .SelColor = RGB(0, &H7A, 0) Then
                    i = InStr(j, strCode, vbCrLf)
                    .SelLength = i - j
                    .SelColor = 0&
                End If
            End If
            i = InStr(j + 1, strCode, Chr(34))
        Wend
        
    End With
End Sub

Sub doCommentBlocks(strCode As String, lStart As Long, startChar As String, stopChar As String)
    Dim i As Long
    Dim j As Long

    With mRTB
        i = InStr(1, strCode, startChar)
        While i > 0
            .SelStart = i - 1 + lStart
        
            j = InStr(i, strCode, stopChar)
            .SelLength = j - i + 2
            .SelColor = RGB(0, &H7A, 0)
            i = InStr(j + 1, strCode, startChar)
        Wend
        
    End With

End Sub

Private Sub doKeyWords(strArray As String, lStart As Long)
'Used for VB Markup
'make all VB keywords blue
'TODO need a new list of keywords and a new array to hold them (and a new sub) for
' the HIGHLIGHT=VB tags
Dim lngIndex As Long
Dim lngPos As Long
Dim inLength As Integer

For lngIndex = 1 To mkeyMax
    '******* 1.10 Start *******
'    lngPos = InStr(1, strArray, mKeyWords(lngIndex))
    '******* 1.10 End *********
    lngPos = InStr(1, strArray, mKeyWords(lngIndex), vbTextCompare)
    
    inLength = Len(mKeyWords(lngIndex))
    While lngPos > 0
        If isOK(inLength, strArray, lngPos) Then
            mRTB.SelStart = lStart + lngPos - 1
            mRTB.SelLength = inLength
            mRTB.SelColor = RGB(0, 0, &H8B)  'dark blue
        End If
        '******* 1.10 Start *******
'        lngPos = InStr(lngPos + inLength, strArray, mKeyWords(lngIndex))
        lngPos = InStr(lngPos + inLength, strArray, mKeyWords(lngIndex), vbTextCompare)
        '******* 1.10 End *********
        DoEvents
    Wend
    
Next lngIndex


End Sub
Private Sub doNewKeyWords(strArray As String, lStart As Long)
'Used for VB Markup
'make all VB keywords blue
'******* 1.10 Start *******
Dim lngIndex As Long
Dim lngPos As Long
Dim inLength As Integer

For lngIndex = 0 To UBound(mNewKeyWords) - 1
    lngPos = InStr(1, strArray, mNewKeyWords(lngIndex), vbTextCompare)
    inLength = Len(mNewKeyWords(lngIndex))
    While lngPos > 0
        If isOK(inLength, strArray, lngPos) Then
            mRTB.SelStart = lStart + lngPos - 1
            mRTB.SelLength = inLength
            mRTB.SelColor = RGB(0, 0, &H8B)  'dark blue
        End If
        lngPos = InStr(lngPos + inLength, strArray, mNewKeyWords(lngIndex), vbTextCompare)
        DoEvents
    Wend
Next lngIndex
'******* 1.10 End *********


End Sub

Private Function isOK(iLen As Integer, strArray As String, iPos As Long) As Boolean
'Used for VB Markup
Dim LeftChar As String, RightChar As String
Dim lcase As Boolean, rcase As Boolean

If iPos > 1 Then
    LeftChar = Mid(strArray, iPos - 1, 1)
Else
    LeftChar = " "
End If

If iPos + iLen <= Len(strArray) Then
    RightChar = Mid(strArray, iPos + iLen, 1)
Else
    RightChar = " "
End If


 If LeftChar = " " Or LeftChar = vbLf Then 'check right char
    Select Case RightChar
        Case " ", ")", vbCr, ","
            isOK = True
        Case Else
            isOK = False
    End Select
 ElseIf RightChar = " " Or RightChar = vbCr Then
    Select Case LeftChar
        Case " ", ".", vbLf
            isOK = True
        Case Else
            isOK = False
    End Select

 Else
    isOK = False
 End If
'If Mid(strArray, iPos, 4) = "Wend" Then Stop
End Function
Private Sub LoadKeywords()
'Used for VB Markup
Dim FF As Integer
Dim strKeyword As String
Static isLoaded As Boolean
If isLoaded Then Exit Sub

FF = FreeFile
Dim i As Integer

ReDim mKeyWords(1 To 200)

i = 0
On Error GoTo fileerror
Open App.Path & "\data\vbkeywords.txt" For Input As #FF
Do
    Input #1, strKeyword
    If Not duplicate(strKeyword, i) Then
        i = i + 1
        mKeyWords(i) = strKeyword
    End If
Loop While Not EOF(FF)
Close FF

mkeyMax = i
ReDim Preserve mKeyWords(1 To mkeyMax)
isLoaded = True

Exit Sub
fileerror:
MsgBox "Can't find " & App.Path & "\data\vbkeywords.txt" & vbCrLf & "VB Code Markup will not work"

End Sub

Private Sub LoadNewKeywords()

'******* 1.10 Start *******
'Used for new-style VB Markup
Dim FF As Integer
Static isLoaded As Boolean

If isLoaded Then Exit Sub

FF = FreeFile

On Error GoTo fileerror
Open App.Path & "\data\vbnewkeywords.txt" For Input As #FF

mNewKeyWords = Split(Input(LOF(FF), FF), ",")

Close FF

'mkeyMax = i
'ReDim Preserve mKeyWords(1 To mkeyMax)
isLoaded = True

Exit Sub
fileerror:
MsgBox "Can't find " & App.Path & "\data\vbnewkeywords.txt" & vbCrLf & "Code Markup will not work"
'******* 1.10 End *********

End Sub

Private Function duplicate(strKeyword As String, iMax As Integer) As Boolean
'Used for VB Markup
Dim i As Integer

For i = 1 To iMax
    If strKeyword = mKeyWords(i) Then
        duplicate = True
        Exit Function
    End If
Next i
duplicate = False

End Function
Sub CaptionBar(Caption As String, halfWidth As Integer, colorCaption As Long, colorBar As Long, _
               Optional strName = "")
    Dim iUp As Byte
    Dim strText As String
    '******* 1.10 Start *******
'    Dim bNeedsNewLine As Boolean
    Dim lngLook As Long
    '******* 1.10 End *********
 
 With mRTB
    
    If IsNull(.SelFontSize) Then
        .SelFontSize = frmViewer.rtbMessage.Font.Size
    End If
    
    iUp = (Int(.SelFontSize) - 1) * 10
    
    If strName <> "" Then
        strText = String(halfWidth, "_") & Caption & String(halfWidth, "_") & vbCrLf _
               & QuotePostedBy & strName & vbCrLf
    Else
        strText = String(halfWidth, "_") & Caption & String(halfWidth, "_") & vbCrLf
    End If

    .SelLength = 0

    '******* 1.10 Start *******
'    If InStr(1, strText, "Quote") Then
'        .SelText = strText
'    Else
'        .SelText = vbCrLf & strText
'    End If
    If Caption = QUOTE_CAPTION Then
        If .SelStart = 0 Then
            .SelText = strText
        Else
            If Asc(Mid$(.Text, .SelStart - 2, 2)) = 32 Then ' could also look for "Originally Posted By"
                .SelText = strText
            Else
                .SelText = vbCrLf & strText
            End If
        End If
    Else
        '******* 1.30k Start *******
'        If isNonNested Then
'            ' We're doing a non-nested quote
'            .SelStart = InStr(1, .Text, TAG_QUOTE_END) + Len(TAG_QUOTE_END)
'        Else
'            .SelStart = InStrRev(.Text, TAG_QUOTE_END, Len(.Text)) - 1
'        End If
        .SelStart = QuotePairsText(1).EndLocation + Len(TAG_QUOTE_END) - 1
        '******* 1.30k End *********
        '******* 1.30k Start *******
'        .SelText = vbCrLf & strText & vbCrLf
        .SelText = vbCrLf & strText
        '******* 1.30k End *********

    End If
    '******* 1.10 End *********
'do 1st bar
    .SelStart = .SelStart - Len(strText)
    
    '******* 1.10 Start *******
    lngLook = .SelStart
    If .SelStart > 0 Then
        Do Until Mid$(.Text, lngLook, 1) <> "_"
            lngLook = lngLook - 1
        Loop
        .SelStart = lngLook
    End If
    '******* 1.10 End *********
    
    .SelLength = halfWidth
    .SelColor = colorBar
    .SelCharOffset = iUp
    '******* 1.10 Start *******
'    If .SelStart <> 0 Then
'        bNeedsNewLine = True
'    End If
    '******* 1.10 End *********
    
'do caption
    .SelStart = .SelStart + halfWidth
    .SelLength = Len(Caption)
    .SelColor = colorCaption
    
'do 2nd bar
    .SelStart = .SelStart + Len(Caption)
    .SelLength = halfWidth
    .SelColor = colorBar
    .SelCharOffset = iUp

'protect it
'    .SelStart = .SelStart - halfWidth - Len(Caption)
'    .SelLength = 2 * halfWidth + Len(Caption)
'    .SelProtected = True

'move pointer past end of bar
    .SelStart = .SelStart + .SelLength + 2
    .SelLength = 0

    '******* 1.10 Start *******
    ' A quote that's mid-line has been found so put it on a new line
'    If bNeedsNewLine Then
'        .TextRTF = Replace(.TextRTF, String(halfWidth, "_") & "\cf2 ", _
'                   "\par " & String(halfWidth, "_") & "\cf2 ", , 1)
'    End If
    '******* 1.10 End *********

    ' Bold the quote name and make sure that the "Originally Posted By..." part
    ' is NOT italicized
    If strName > "" Then
        .TextRTF = Replace(.TextRTF, QUOTE_POSTED_BY & strName, _
                   RTF_ITALIC_END & QuotePostedBy & RTF_BOLD_START & strName & RTF_BOLD_END & RTF_ITALIC_START, 1, 1)
    End If
    
    '******* 1.10 Start *******
    ' The "Quote" should not be italicized either
    If Caption > "" Then
        .TextRTF = Replace(.TextRTF, Caption, _
                   RTF_ITALIC_END & Caption & RTF_ITALIC_START)
    End If
    '******* 1.10 End *********
    
    End With
    

End Sub

'******* 1.30n Start *******
'Sub VBCaptionBar(bTopBar As Boolean)
Sub VBCaptionBar(bTopBar As Boolean, strType As String)
'******* 1.30n End *********
    
    Dim iUp As Byte
    Dim strBar As String
    '******* 1.10 Start *******
    Dim intSaveLength As Integer
    Dim lngSaveStart As Long
    '******* 1.10 End *********
    '******* 1.30n Start *******
    Dim strStartTag As String
    Dim strEndTag As String
    Dim strCaption As String
    
    Select Case strType
        Case TAG_VBCODE_START
            strStartTag = strType
            strEndTag = TAG_VBCODE_END
            strCaption = VBCaption
        Case TAG_CODE_START
            strStartTag = strType
            strEndTag = TAG_CODE_END
            strCaption = CodeCaption
    End Select
    '******* 1.30n End *********
 
 With mRTB
    
    If IsNull(.SelFontSize) Then
        .SelFontSize = frmViewer.rtbMessage.Font.Size
    End If
    
    iUp = (Int(.SelFontSize) - 1) * 10
    
    ' Write bar (the complete bar, not just half of it as with quotes)
    If bTopBar Then
        ' Display
        ' _______________
        ' visual basic code:              or Code:
        '________________
        '******* 1.30n Start *******
'        strBar = vbCrLf & String(VBBARLEN, "_") & vbCrLf & VBCaption _
'               & vbCrLf & String(VBBARLEN, "_") & vbCrLf
        strBar = vbCrLf & String(VBBARLEN, "_") & vbCrLf & strCaption _
               & vbCrLf & String(VBBARLEN, "_") & vbCrLf
        '******* 1.30n End *********
    Else
        strBar = String(VBBARLEN, "_") & vbCrLf
    End If
    
    '******* 1.10 Start *******
'    .SelLength = 0
'    .SelText = vbCrLf & strBar
'    .SelStart = .SelStart - Len(strBar)
    '******* 1.10 End *********
    
    .SelLength = 0
    
    If bTopBar Then
        '******* 1.10 Start *******
'        .SelLength = VBBARLEN * 2 + Len(VBCaption) + 6
        .SelText = vbCrLf & strBar
        '******* 1.10 End *********
        .SelStart = .SelStart - Len(strBar)
        .SelLength = Len(strBar)
    Else
        '******* 1.10 Start *******
        '******* 1.30n Start *******
'        .SelStart = InStr(1, .Text, TAG_VBCODE_END) + Len(TAG_VBCODE_END) - 1
        .SelStart = InStr(1, .Text, strEndTag) + Len(strEndTag) - 1
        '******* 1.30n End *********
        .SelLength = 0
        .SelText = vbCrLf & strBar
        .SelStart = .SelStart - (Len(strBar))
        .SelLength = Len(strBar)
        '******* 1.10 End *********
    End If
    .SelColor = RGB(0, &H7A, 0)
    
    '******* 1.10 Start *******
    intSaveLength = .SelLength
    lngSaveStart = .SelStart
    
    If bTopBar Then
        '******* 1.30n Start *******
'        .SelStart = InStr(.SelStart, .Text, VBCaption) - 1
'        .SelLength = Len(VBCaption)
        .SelStart = InStr(.SelStart, .Text, strCaption) - 1
        strBar = vbCrLf & String(VBBARLEN, "_") & vbCrLf & strCaption _
               & vbCrLf & String(VBBARLEN, "_") & vbCrLf
        .SelLength = Len(strCaption)
        '******* 1.30n End *********
        .SelCharOffset = -iUp
    End If
    '******* 1.10 End *********
    
'move pointer past end of bar
    '******* 1.10 Start *******
'    .SelStart = .SelStart + .SelLength + 2
    '******* 1.30n Start *******
'    .SelStart = lngSaveStart + intSaveLength + Len(TAG_VBCODE_START) + 1
    .SelStart = lngSaveStart + intSaveLength + Len(strEndTag) + 1
    '******* 1.30n End *********
    '******* 1.10 End *********
    
    .SelLength = 0
    
    End With

End Sub

Sub HighlightCaptionBar(bTopBar As Boolean, strStartTag As String, strEndTag As String)
    
    '******* 1.10 Start *******
    Dim iUp As Byte
    Dim strBar As String
    Dim intSaveLength As Integer
    Dim lngSaveStart As Long
 
 With mRTB
    
    If IsNull(.SelFontSize) Then
        .SelFontSize = frmViewer.rtbMessage.Font.Size
    End If
    
    iUp = (Int(.SelFontSize) - 1) * 10
    
    ' Write bar (the complete bar, not just half of it as with quotes)
    If bTopBar Then
        ' Display
        ' _______________
        ' visual basic code
        '________________
        strBar = vbCrLf & String(VBBARLEN, "_") & vbCrLf & VBCaption _
               & vbCrLf & String(VBBARLEN, "_") & vbCrLf
    Else
        strBar = String(VBBARLEN, "_") & vbCrLf
    End If
    
    .SelLength = 0
    
    If bTopBar Then
        .SelText = vbCrLf & strBar
        .SelStart = .SelStart - Len(strBar)
        .SelLength = Len(strBar) - 1
    Else
        .SelStart = InStr(1, .Text, strEndTag) + Len(strEndTag) - 1
        .SelLength = 0
        .SelText = vbCrLf & strBar
        .SelStart = .SelStart - (Len(strBar))
        .SelLength = Len(strBar)
    End If
    .SelColor = RGB(0, &H7A, 0)
    
    intSaveLength = .SelLength
    lngSaveStart = .SelStart
    
    If bTopBar Then
        .SelStart = InStr(.SelStart, .Text, VBCaption) - 1
        .SelLength = Len(VBCaption)
        .SelCharOffset = -iUp
    End If
    
    'move pointer past end of bar
    .SelStart = lngSaveStart + intSaveLength + Len(strStartTag) + 1
    
    .SelLength = 0
    
    End With
    '******* 1.10 End *********

End Sub

Private Sub Class_Initialize()
 LoadKeywords
 '******* 1.10 Start *******
 LoadNewKeywords
 '******* 1.10 End *********

End Sub
Public Function QuotePostedBy() As String
    QuotePostedBy = QUOTE_POSTED_BY
End Function

Public Sub doLineNumbers(strStartTag As String, strEndTag As String)

    '******* 1.10 Start *******
    Dim strLines() As String
    Dim intLine As Integer
    Dim strLeft As String
    Dim strRight As String
    Dim lngStartPos As Long
    Dim lngEndPos As Long
    Dim strCode As String
    Dim lngIndex As Long
    Dim bFoundALine
    
    With mRTB
        ' Store the stuff before the code lines
        lngStartPos = InStr(1, .TextRTF, strStartTag)
        strLeft = VBA.Left(.TextRTF, lngStartPos + Len(strStartTag) - 1)
        ' Store the stuff after the code lines
        lngEndPos = InStr(1, .TextRTF, strEndTag)
        strRight = Right$(.TextRTF, Len(.TextRTF) - (lngEndPos - 1))
        ' Isolate the code lines
        strCode = Mid$(.TextRTF, lngStartPos + Len(strStartTag), _
                                 lngEndPos - (lngStartPos + Len(strEndTag) + 2))
        ' Split the code into lines at the "\par "
        strLines = Split(strCode, "\par ")
        
        lngStartPos = InStr(1, strCode, "\par")
        If lngStartPos = 0 Then
            ' There is just one line of code
            strCode = Format(1, "@@@@. ") & strCode
            .TextRTF = strLeft & strCode & strRight
            Exit Sub
       Else
            ' Prepend "\par " and a line number to the pieces
            For lngIndex = 0 To UBound(strLines) - 1
                If lngIndex = 0 Then
                    ' Get rid of some rtf that gets in the way
                    strLines(0) = Replace(strLines(0), "\cf1\f1 ", "")
                    strLines(0) = Replace(strLines(0), "\f1 ", "")
                End If
                strLines(lngIndex) = "\par " & Format(lngIndex + 1, "@@@@. ") & strLines(lngIndex)
            Next
        End If
        ' Put Humpty Dumpty back together
        strCode = ""
        For lngIndex = 0 To UBound(strLines) - 1
            strCode = strCode & strLines(lngIndex)
        Next
        .TextRTF = strLeft & strCode & strRight
    End With
    '******* 1.10 End *********
    
End Sub
