Attribute VB_Name = "modViewer"
Option Explicit

Public Const TAG_ITALIC_START As String = "[I]"
Public Const TAG_ITALIC_END As String = "[/I]"
Public Const TAG_BOLD_START As String = "[B]"
Public Const TAG_BOLD_END As String = "[/B]"
Public Const TAG_ULINE_START As String = "[U]"
Public Const TAG_ULINE_END As String = "[/U]"
Public Const TAG_QUOTE_START As String = "[QUOTE]"
Public Const TAG_QUOTE_START_NCB As String = "[QUOTE" 'Note: no closing bracket
Public Const TAG_QUOTE_EQUAL_NCB As String = "[QUOTE=" 'Note: no closing bracket
Public Const TAG_CLOSE_BRACKET As String = "]"
Public Const TAG_OPEN_BRACKET As String = "["
Public Const TAG_EQUAL As String = "="
Public Const TAG_QUOTE_END As String = "[/QUOTE]"
Public Const TAG_URL_START As String = "[URL]"
Public Const TAG_URL_START_NCB As String = "[URL"
Public Const TAG_URL_EQUAL_NCB As String = "[URL=" 'Note: no closing bracket
Public Const TAG_URL_END As String = "[/URL]"
'******* 1.30m Start *******
Public Const TAG_THREAD_START_NCB As String = "[THREAD=" 'Note: no closing bracket
Public Const TAG_THREAD_END As String = "[/THREAD]"
Public Const TAG_POST_START_NCB As String = "[POST="
Public Const TAG_POST_END As String = "[/POST]"
'******* 1.30m End *********
Public Const TAG_LISTB_START As String = "[LIST]"
Public Const TAG_LISTB_END = "[/LIST]"
Public Const TAG_LISTN_START As String = "[LIST=1]"
Public Const TAG_LISTN_END = "[/LIST=1]"
Public Const TAG_EMAIL_START As String = "[EMAIL]"
Public Const TAG_EMAIL_END As String = "[/EMAIL]"
Public Const TAG_FONTSIZE_START_NCB As String = "[SIZE="
Public Const TAG_FONTSIZE_END As String = "[/SIZE]"
'******* 1.30h Start *******
'Public Const TAG_HL_START_NCB As String = "[HL="
'******* 1.30h End *********
Public Const TAG_HL_END As String = "[/HL]"
Public Const TAG_COLOR_START_NCB As String = "[COLOR="
Public Const TAG_COLOR_END As String = "[/COLOR]"
Public Const TAG_IMAGE_START As String = "[IMG]"
Public Const TAG_IMAGE_END As String = "[/IMG]"
Public Const TAG_VBCODE_START As String = "[VBCODE]"
Public Const TAG_VBCODE_END As String = "[/VBCODE]"
'******* 1.30n Start *******
Public Const TAG_CODE_START As String = "[CODE]"
Public Const TAG_CODE_END As String = "[/CODE]"
'******* 1.30n End *********
'******* 1.10 Start *******
Public Const TAG_HIGHLIGHT_END As String = "[/HIGHLIGHT]"
'******* 1.10 End *********
Public Const TAG_SUPERSCRIPT_START As String = "[SUP]"
Public Const TAG_SUPERSCRIPT_END As String = "[/SUP]"
Public Const TAG_SUBSCRIPT_START As String = "[SUB]"
Public Const TAG_SUBSCRIPT_END As String = "[/SUB]"
'******* 1.30d Start *******
Public Const TAG_INDENT_START As String = "[INDENT]"
Public Const TAG_INDENT_END As String = "[/INDENT]"
'******* 1.30d End *********
'******* 1.30o Start *******
Public Const TAG_NOPARSE_START As String = "[NOPARSE]"
Public Const TAG_NOPARSE_END As String = "[/NOPARSE]"
Public Const TAG_CHANGED_IND As String = "[!"
'******* 1.30o End *********

Public Const RTF_PARAGRAPH As String = "\par "
Public Const RTF_ITALIC_START As String = "\i "
Public Const RTF_ITALIC_END As String = "\i0 "
Public Const RTF_BOLD_START As String = "\b "
Public Const RTF_BOLD_END As String = "\b0  "
'******* 1.30l Start *******
'Public Const RTF_ULINE_START As String = "\u "
'Public Const RTF_ULINE_END As String = "\u0 "
Public Const RTF_ULINE_START As String = "\ul "
Public Const RTF_ULINE_END As String = "\ul0 "
'******* 1.30l End *********
Public Const RTF_INVISIBLE_START As String = "\v "
'******* 1.30l Start *******
'Public Const RTF_INVISIBLE_END As String = "\v0  "
Public Const RTF_INVISIBLE_END As String = "\v0 "
'******* 1.30l End *********
Public Const RTF_GIF_START As String = "\v\'10s"
Public Const RTF_GIF_END As String = "\'11\v0 "

Public Const CANCEL = 32755
Public Const MAILTO = "MailTo:"
'******* 1.30m Start *******
Public Const VBF_THREAD_URL = "http://www.vbforums.com/showthread.php?t="
Public Const VBF_POST_URL = "http://www.vbforums.com/showthread.php?p="
'******* 1.30m End *********

Public Const VBBARLEN = 46
'******* 1.10 Start *******
' For quotes
Public Const QUOTE_HEADER = "____________________ Quote ____________________"
Public Const QUOTE_FOOTER = "______________________________________________"
Public Type typQuotePairs
    Pair As Integer
    StartLocation As Long
    EndLocation As Long
    IndentLevel As Integer
End Type

Public QuotePairsRTF() As typQuotePairs
Public QuotePairsText() As typQuotePairs
'******* 1.30k Start *******
'Public isNonNested As Boolean
'******* 1.30k End *********

'******* 1.20k Start *******
Public gstrFiles As String
'******* 1.20k End *********

'******* 1.10 End *********
Public Sub DisplayError(sRoutine As String)
'***************************************************************************
'Purpose: Common error display routine
'Inputs:  None
'Outputs: None
'***************************************************************************
    
    Dim sMsg As String

    sMsg = "Error # " & str(Err.Number) & " was generated by " _
        & Err.Source & " in routine " & sRoutine & "." _
        & Chr(13) & Chr(13) & Err.Description
    Beep
    MsgBox sMsg, , "Error", Err.HelpFile, Err.HelpContext
   
End Sub

Public Function StripAmpersand(strText As String) As String

    '******* 1.30a Start *******
    StripAmpersand = Replace(strText, "&", "")
    '******* 1.30a End *********
    
End Function
