Attribute VB_Name = "modCallBack"
Option Explicit

Private Declare Function GetWindowLongPtr Lib "user32" Alias "GetWindowLongA" ( _
    ByVal hwnd As Long, _
    ByVal nIndex As Long _
) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    pDest As Any, _
    pSrc As Any, _
    ByVal ByteLen As Long _
)

Private Const GWLP_WNDPROC = (-4)
Private Const GWLP_USERDATA = (-21)


Private Declare Function GetProp Lib "user32" Alias "GetPropA" ( _
    ByVal hwnd As Long, _
    ByVal lpString As String _
) As Long

Public Function MainCLSProc(ByVal hwnd As Long, ByVal Msg As Long, _
    ByVal wParam As Long, ByVal lParam As Long) As Long
    
Dim clsRefToCLS As clsSubClass
Dim pUserData As Long
    
    pUserData = GetProp(hwnd, "objptr")
    
    If pUserData Then
        Set clsRefToCLS = ObjFromPtr(pUserData)
        MainCLSProc = clsRefToCLS.CLSProc(hwnd, Msg, wParam, lParam)
        Set clsRefToCLS = Nothing
    End If
    
End Function


Private Function ObjFromPtr(ByVal lpObject As Long) As Object
Dim objTemp As Object
    CopyMemory objTemp, lpObject, 4&
    Set ObjFromPtr = objTemp
    CopyMemory objTemp, 0&, 4&
End Function

