Attribute VB_Name = "modChangeLog"
Option Explicit

'*********************************************************************************
'*                                  CHANGE LOG                                   *
'*********************************************************************************
'Release   Date      Change Description
'-------   --------  -------------------------------------------------------------
'0.01      02/18/07  o 2nd upload to VB Forums.
'                    o Converts tags for bold, italic and underlined fonts
'                    o Converts tags for quotes, bulleted and numbered lists,
'                      smilies (smilies don't animate and their backgrong is
'                      non-transparent), URL hyperlinks and Email Links.
'                    o Words selected by content are highlighted.
'                    o PMs displayed in datestamp order
'                    o Added First and Last buttons
'0.02      02/21/07  o Export to text and rich text
'                    o Convert font size ([SIZE=n]) tags
'                    o Convert highlighting ([HL=#n]) tags
'                    o Convert font color ([COLOR= ) tags
'                    o Convert image ([IMG]) tags
'                    o Convert VBCode tags
'                    o Convert both super and subscript tags
'                    o changed form to fixed single and added save window position code
'1.00      02/25/07  o Allow multiple files to be opened
'                    o GIFs animate
'1.10      03/10/07  o Export to XML
'                    o corrected non-amination of animated smilies where there is a non-aminated
'                      one in the PM.
'                    o Added overwrite prompt warning in mnuExportRTF and mnuExportText
'                    o Corrected error caused when total lenght of filenames exceeded 256
'                    o Added selection by folder name
'                    o Added save window position, animate smilies and VB code formatting menu options
'                    o corrected italicization
'                    o Added display of file name(s)
'                    o Added mnuExit to menu items
'                    o Added ability to not translate smilies in a given PM
'                    o Print the current PM
'                    o Right-click hidden URL display
'                    o Added code to allow unmatched tags to be seen
'                    o Added member name selection from list rather than manual input
'1.20      04/06/10  (a) Added ability to delete a PM
'                    (b) At some point vBulletin added a new "fromuserid" node in the XML file
'                        so I needed to add code to handle both the old and new file formats
'                    (c) Added ability to jump to a particular PM number
'                    (d) Improved the Exit code
'                    (e) Vastly improve the loading of the PM records
'                    (f) Add ToolTips
'                    (i) When the To name consists of multiple names add the ability to find the PM
'                        using any of the names rather than the multiple-name string
'                    (j) Save the path to the folder where the XML files are stored
'                    (k) Add a tooltip-like display that shows all the PM file names if they
'                        don't all fit in lblFileName
'                    (l) Made it unnecessary to click cmdViewPMs when the files are opened and
'                        changed UI a bit
'                    (z) Misc tweeks
'1.30      04/??/10  (a) Added wildcard and multiple-word ability to search by content option.
'                    (b) in the search by content process, don't highlight text in tags and
'                        partucularly don't hightlight the word "Quote" in a quote header if
'                        it happens that "Quote" is being looked for.
'                    (c) Workarounds for bad/unmatched tags
'                    (d) Add support for Indent tags
'                    (e) Changed Date/Time display and added folder name to display
'                    (f) Fixed a problem where smilies are right next to each other
'                    (g) Fixed problem with some color names
'                    (h) Fixed problem with default, yellow, highlighting
'                    (i) Corrected a problem with the loading of the PM records
'                    (j) Partially fixed a problem with some URL links
'                    (k) Fixed/improved the formatting of quotes quotes
'                    (l) Fixed bolding and underlining problems
'                    (m) Add support for Thread and Post tags
'                    (n) Add support for Code tags
'                    (o) Add support for Noparse tags

'                    (z) o Increased the space for the To name on frmViewer so that 5 names will fit
'                        o Added a bunch of error handling
'                        o Set focus at start to txtJump
'                        o Fixed a bug in Links processing for URLs


'TODO
' [right]
' [left]
' [center]
' C++ code?

'PROBLEMS
' None

' Rich Text Format (RTF) Version 1.5 Specification
' http://www.biblioscape.com/rtf15_spec.htm

' XPath examples
' http://www.w3schools.com/xpath/xpath_examples.asp

' moeur's CodeBank entry
' http://www.vbforums.com/showthread.php?t=355994

' TopXML
'http://www.topxml.com/xsl/funcsubstring.asp

' Rob's Res File
'http://vbforums.com/showthread.php?t=432036

'   to specify a particular touser
'   Set oxmlNodeList = XMLdoc.documentElement.selectNodes("//privatemessage[touser='MartinLiss']/touser")
    ' Specify a date
'    Set oxmlNodeList = XMLdoc.documentElement.selectNodes("//privatemessage" _
'                     & "[substring(translate(datestamp, '-', ''),1,10) > '20070101']")
                     

